unit U_YarnListSel;

interface

uses
  Windows, Messages, SysUtils, StrUtils, Variants, Classes, Graphics, Controls,
  Forms, ComObj, Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit,
  DB, ADODB, cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin,
  StdCtrls, cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP, ShellAPI, IniFiles, cxCheckBox, cxCalendar, cxButtonEdit,
  cxTextEdit, Menus, cxLookAndFeelPainters, cxButtons, cxContainer, cxImage,
  cxDBEdit;

type
  FdDy = record
    inc: integer; //客户端套接字句柄
    FDdys: string[32]; //客户端套接字
    FdDysName: string[32]; //客户端套接字
  end;

  TfrmYarnListSel = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    Panel1: TPanel;
    ToolButton2: TToolButton;
    ADOQueryMain: TADOQuery;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    Label3: TLabel;
    Y_CodeName: TEdit;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    cxGridLevel1: TcxGridLevel;
    cxGridPopupMenu2: TcxGridPopupMenu;
    DS_HZ: TDataSource;
    CDS_HZ: TClientDataSet;
    ToolButton3: TToolButton;
    v2Column6: TcxGridDBColumn;
    v2Column2: TcxGridDBColumn;
    v2Column3: TcxGridDBColumn;
    v2Column4: TcxGridDBColumn;
    Label1: TLabel;
    Y_Code: TEdit;
    OpenDialog1: TOpenDialog;
    v2Column14: TcxGridDBColumn;
    v2Column15: TcxGridDBColumn;
    Label7: TLabel;
    Y_Spec: TEdit;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure Y_CodeNameChange(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure Tv2DblClick(Sender: TObject);
  private
    fFlileFlag: string;
    { Private declarations }
    procedure InitGrid();
    procedure InitImage();
    procedure LookImage(FileName: string);
  public
    fkhType: string;
    canshu1: string;
    dFdDy: array[0..20] of FdDy; //客户端连接数组
  end;

var
  frmYarnListSel: TfrmYarnListSel;

implementation

uses
  U_DataLink, U_Fun, U_ZDYHelp;

{$R *.dfm}
procedure TfrmYarnListSel.LookImage(FileName: string);
begin

end;

procedure TfrmYarnListSel.InitImage();
begin

end;

procedure TfrmYarnListSel.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      SQL.Clear;
      sql.Add(' select  *');
      sql.Add(' from BS_SX_YDang A where Y_Type=''SX'' ');
      sql.Add(' order by FillTime desc ');
      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_HZ);
    SInitCDSData20(ADOQueryMain, CDS_HZ);
  finally
    ADOQueryMain.EnableControls;
    ToolButton2.Click;
  end;
end;

procedure TfrmYarnListSel.FormDestroy(Sender: TObject);
begin
  frmYarnListSel := nil;
end;

procedure TfrmYarnListSel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmYarnListSel.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('产品资料13', Tv2, '客户自定义');
  Close;
end;

procedure TfrmYarnListSel.FormShow(Sender: TObject);
begin
  ReadCxGrid('产品资料13', Tv2, '客户自定义');
  InitGrid();
end;

procedure TfrmYarnListSel.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmYarnListSel.ToolButton2Click(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS20(ADOQueryMain, CDS_HZ);
    SInitCDSData20(ADOQueryMain, CDS_HZ);
  end;
end;

procedure TfrmYarnListSel.Y_CodeNameChange(Sender: TObject);
begin
  ToolButton2.Click;
end;

procedure TfrmYarnListSel.ToolButton5Click(Sender: TObject);
var
  excelApp, WorkBook: Variant;
  i, j, k, ExcelRowCount: integer;
  maxId: string;
begin

  try
    excelApp := CreateOleObject('Excel.Application');
    openDialog1.Filter := '*.CSV;*.xls';
    if opendialog1.Execute then
    begin
      WorkBook := excelApp.WorkBooks.Open(OpenDialog1.FileName);
    end
    else
      exit;

    excelApp.Visible := false;
    ExcelRowCount := WorkBook.WorkSheets[1].UsedRange.Rows.Count;
  except
    application.MessageBox('加载EXCEL错误！', '错误信息', MB_ICONERROR);
    exit;
  end;

  try
    k := 0;
    for i := 1 to 20 do
    begin
      if trim(excelApp.Cells[1, i].value) = '' then
        break;
      if trim(excelApp.Cells[1, i].value) = '产品编号' then
      begin
        dFdDy[k].inc := i;
        dFdDy[k].FDdys := 'ZdyCode';
        dFdDy[k].FdDysName := '产品编号';
      end;

      if trim(excelApp.Cells[1, i].value) = '产品名称' then
      begin
        dFdDy[k].inc := i;
        dFdDy[k].FDdys := 'ZdyName';
        dFdDy[k].FdDysName := '产品名称';
      end;

      if trim(excelApp.Cells[1, i].value) = '中文名称' then
      begin
        dFdDy[k].inc := i;
        dFdDy[k].FDdys := 'defNote3';
        dFdDy[k].FdDysName := '中文名称';
      end;

      if trim(excelApp.Cells[1, i].value) = '颜色' then
      begin
        dFdDy[k].inc := i;
        dFdDy[k].FDdys := 'DEFstr3';
        dFdDy[k].FdDysName := '颜色';
      end;
      if trim(excelApp.Cells[1, i].value) = '中文颜色' then
      begin
        dFdDy[k].inc := i;
        dFdDy[k].FDdys := 'DEFstr6';
        dFdDy[k].FdDysName := '中文颜色';
      end;

      if trim(excelApp.Cells[1, i].value) = '类型' then
      begin
        dFdDy[k].inc := i;
        dFdDy[k].FDdys := 'DEFstr5';
        dFdDy[k].FdDysName := '类型';
      end;
      if trim(excelApp.Cells[1, i].value) = '规格' then
      begin
        dFdDy[k].inc := i;
        dFdDy[k].FDdys := 'DEFstr1';
        dFdDy[k].FdDysName := '规格';
      end;
      if trim(excelApp.Cells[1, i].value) = '成份' then
      begin
        dFdDy[k].inc := i;
        dFdDy[k].FDdys := 'DEFstr2';
        dFdDy[k].FdDysName := '成份';
      end;
      k := k + 1;
    end;
  except
  end;

  ADOQueryCmd.Connection.BeginTrans;
  try
    for i := 2 to ExcelRowCount do
    begin
      if GetLSNo(ADOQueryCmd, maxId, 'AT', 'KH_Zdy_Attachment', 4, 1) = False then
      begin
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('取最大号失败！', '提示', 0);
        Exit;
      end;

      with ADOQueryCmd do
      begin
        close;
        sql.Clear;
        sql.Add('select * from KH_Zdy_Attachment where 1=2');
        open;
      end;
      ADOQueryCmd.Append;
      for j := 0 to k - 1 do
      begin
        ADOQueryCmd.fieldbyname(dFdDy[j].FDdys).Value := excelApp.Cells[i, dFdDy[j].inc].Value;
      end;
      ADOQueryCmd.FieldByName('ATID').Value := Trim(maxId);
      ADOQueryCmd.FieldByName('zdyCode').Value := Trim(maxId);
      ADOQueryCmd.FieldByName('khType').Value := Trim(fkhType);
      ADOQueryCmd.FieldByName('Type').Value := 'CP';
      ADOQueryCmd.FieldByName('Filler').Value := Trim(DName);
      ADOQueryCmd.Post;


 {     with ADOQueryTemp do
      begin
        close;
        sql.Clear;
        sql.Add('select * from KH_Zdy_Attachment where ATID='''+trim(maxId)+''' ');
        open;
      end;

      with ADOQueryCmd do
      begin
        Close;
        SQL.Clear;
        sql.Add('select * from KH_Zdy where ZdyNo='''+Trim(maxId)+'''');
        Open;
      end;
      with ADOQueryCmd do
      begin
        if ADOQueryCmd.IsEmpty then
        begin
          Append;
        end else
        begin
          Edit;
        end;
        FieldByName('ZdyNo').Value:=Trim(maxId);
        FieldByName('ZdyName').Value:=Trim(ADOQueryTemp.fieldbyname('ZdyName').AsString);
        FieldByName('Type').Value:='CP';
        FieldByName('MainType').Value:=Trim(ADOQueryTemp.fieldbyname('DEFstr5').AsString);
        Post;
      end;}
    end;
    WorkBook.Close;
    excelApp.Quit;
    excelApp := Unassigned;
    WorkBook := Unassigned;
    ADOQueryCmd.Connection.CommitTrans;
    InitGrid();
  except
    WorkBook.Close;
    excelApp.Quit;
    excelApp := Unassigned;
    WorkBook := Unassigned;
    ADOQueryCmd.Connection.RollbackTrans;
  end;
end;

procedure TfrmYarnListSel.ToolButton3Click(Sender: TObject);
begin
  if CDS_HZ.IsEmpty then
    exit;
  ModalResult := 1;
end;

procedure TfrmYarnListSel.Tv2DblClick(Sender: TObject);
begin
  if CDS_HZ.IsEmpty then
    exit;
  ModalResult := 1;
end;

end.

